## lola 1.4

=== Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
#

CFLAGS=-g -O2 -I. -Wall -Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs

DESTDIR = 
PREFIX = /usr/local
BINDIR = $(PREFIX)/bin
MANDIR = $(PREFIX)/share/man

all: lola calc pycalc

lola: lola.py
	cp lola.py lola
	chmod +x lola

calc: calc.c calc-gram.h
	cc $(CFLAGS) -o $@ calc.c

calc-gram.h: calc-gram.ll lola.py
	python3 ./lola.py -o $@ calc-gram.ll

pycalc: pycalc.py pycalc_gram.py
	cp pycalc.py $@
	chmod +x pycalc

pycalc_gram.py: pycalc_gram.ll lola.py
	python3 ./lola.py -o $@ --format=python pycalc_gram.ll

install: lola lola.1
	install -d $(DESTDIR)$(BINDIR)
	install lola $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install lola.1 $(DESTDIR)$(MANDIR)/man1

clean:
	rm -f lola calc pycalc calc-gram.h pycalc_gram.py

## lola 1.2

=== debian/changelog ===
lola (1.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change rebuild to allow testing migration. 

 -- Boyuan Yang <byang@debian.org>  Tue, 24 Sep 2019 15:19:37 -0400

lola (1.2-2) unstable; urgency=medium

  * Update debian copyright information

 -- Keith Packard <keithp@keithp.com>  Fri, 13 Sep 2019 08:40:28 -0700

lola (1.2-1) unstable; urgency=medium

  * Upstream 1.2 version
  * Use /usr/bin/env to locate python3 binary
    (Paulo Henrique Silva <ph.silva@gmail.com>)
  * Make non_terminal_table an ordered dict
    (Paulo Henrique Silva <ph.silva@gmail.com>)
  * Pack parse_return_t enum to reduce space used
  * Add preprocessing functionality

 -- Keith Packard <keithp@keithp.com>  Wed, 21 Aug 2019 21:10:52 -0700

lola (1.1-2) unstable; urgency=medium

  * Clean up some lintian warnings

 -- Keith Packard <keithp@keithp.com>  Wed, 06 Mar 2019 22:31:08 +0100

lola (1.1-1) unstable; urgency=medium

  * Reduce size of non-terminal table
  * Switch from arch: any to arch: all

 -- Keith Packard <keithp@keithp.com>  Sat, 02 Mar 2019 08:45:46 -0800

lola (1.0-1) unstable; urgency=medium

  * Initial upload

 -- Keith Packard <keithp@keithp.com>  Wed, 20 Feb 2019 21:04:47 -0800

=== debian/control ===
Source: lola
Section: devel
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Homepage: https://keithp.com
Build-Depends: debhelper (>= 12), python3
Standards-Version: 4.4.0

Package: lola
Architecture: all
Depends: python3, ${misc:Depends}
Description: LL parser generator
 Lola is a general-purpose LL parser generator that converts a grammar
 describing an LL context-free language into either a C or Python program
 to parse the language.

## lola 1.3

=== debian/changelog ===
lola (1.3-1) unstable; urgency=medium

  * Support mutually-recursive grammars
  * Remove debugging prints from preprocessor code

 -- Keith Packard <keithp@keithp.com>  Tue, 18 Feb 2020 11:28:46 -0800

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Keith Packard <keithp@keithp.com>
 Homepage: https://keithp.com
-Build-Depends: debhelper (>= 12), python3
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (= 12), python3
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 
 Package: lola
 Architecture: all

## lola 1.4

=== debian/changelog ===
lola (1.4-1) unstable; urgency=medium

  * New upstream version
  * Improve memory/cpu usage of terminal table
  * Fix bug dealing with repeated non-terminals in productions

 -- Keith Packard <keithp@keithp.com>  Fri, 28 Aug 2020 23:16:11 -0700

lola (1.3-2) unstable; urgency=medium

  * Source-only upload

 -- Keith Packard <keithp@keithp.com>  Mon, 09 Mar 2020 12:54:26 -0700

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Keith Packard <keithp@keithp.com>
 Homepage: https://keithp.com
-Build-Depends: debhelper-compat (= 12), python3
+Build-Depends: debhelper-compat (= 13), python3
 Rules-Requires-Root: no
 Standards-Version: 4.5.0

## lola 1.5

=== debian/changelog ===
lola (1.5-1) unstable; urgency=medium

  * New upstream version
  * Standards 4.5.1
  * Add 'PARSE_TOP' fragment.

 -- Keith Packard <keithp@keithp.com>  Thu, 16 Sep 2021 17:05:14 -0700

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Homepage: https://keithp.com
 Build-Depends: debhelper-compat (= 13), python3
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 
 Package: lola
 Architecture: all

## lola 1.6

=== debian/changelog ===
lola (1.6-1) unstable; urgency=medium

  * New upstream version
  * Don't create output file if there is an error

 -- Keith Packard <keithp@keithp.com>  Fri, 05 Nov 2021 10:50:52 -0700

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Homepage: https://keithp.com
 Build-Depends: debhelper-compat (= 13), python3
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 
 Package: lola
 Architecture: all

## lola 1.7

=== debian/changelog ===
lola (1.7-1) unstable; urgency=medium

  * New upstream version
  * Fix regex warnings
  * Support --version flag

 -- Keith Packard <keithp@keithp.com>  Sun, 27 Oct 2024 12:39:09 -0700

## lola 1.8

=== Makefile ===
--- 
+++ 
@@ -16,14 +16,14 @@
 # 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-CFLAGS=-g -O2 -I. -Wall -Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs
+CFLAGS=-g -Os -I. -Wall -Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs
 
 DESTDIR = 
 PREFIX = /usr/local
 BINDIR = $(PREFIX)/bin
 MANDIR = $(PREFIX)/share/man
 
-all: lola calc pycalc
+all: lola calc pycalc json pyjson
 
 lola: lola.py
 	cp lola.py lola
@@ -42,6 +42,19 @@
 pycalc_gram.py: pycalc_gram.ll lola.py
 	python3 ./lola.py -o $@ --format=python pycalc_gram.ll
 
+pyjson: pyjson.py pyjson_gram.py
+	cp pyjson.py $@
+	chmod +x pyjson
+
+pyjson_gram.py: pyjson_gram.ll lola.py
+	python3 ./lola.py -o $@ --format=python pyjson_gram.ll
+
+json: json.c json-gram.h
+	cc $(CFLAGS) -o $@ json.c
+
+json-gram.h: json-gram.ll lola.py
+	python3 ./lola.py -o $@ json-gram.ll
+
 install: lola lola.1
 	install -d $(DESTDIR)$(BINDIR)
 	install lola $(DESTDIR)$(BINDIR)
@@ -49,4 +62,4 @@
 	install lola.1 $(DESTDIR)$(MANDIR)/man1
 
 clean:
-	rm -f lola calc pycalc calc-gram.h pycalc_gram.py
+	rm -f lola calc pycalc calc-gram.h pycalc_gram.py json json-gram.h pyjson_gram.py

=== debian/changelog ===
lola (1.8-2) unstable; urgency=medium

  * Mark python3 dependency with :any
  * Add Multi-Arch: foreign

 -- Keith Packard <keithp@keithp.com>  Wed, 20 Nov 2024 13:08:41 -0800

lola (1.8-1) unstable; urgency=medium

  * New upstream version
  * Allow targets to redefine what 'const' means.

 -- Keith Packard <keithp@keithp.com>  Wed, 20 Nov 2024 12:58:36 -0800

=== debian/control ===
Source: lola
Section: devel
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Homepage: https://keithp.com
Build-Depends: debhelper-compat (= 13), python3:any
Rules-Requires-Root: no
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/debian/lola.git
Vcs-Browser: https://salsa.debian.org/debian/lola.git

Package: lola
Architecture: all
Depends: python3:any, ${misc:Depends}
Multi-Arch: foreign
Description: LL parser generator
 Lola is a general-purpose LL parser generator that converts a grammar
 describing an LL context-free language into either a C or Python program
 to parse the language.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ -- PREFIX=/usr

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
git://keithp.com/git/lola \
refs/tags/([\d\.]+) debian uupdate
